org.codehaus.groovy.reflection

## Class CachedMethod

- java.lang.Object
- - org.codehaus.groovy.reflection.ParameterTypes
  - - groovy.lang.MetaMethod
    - - org.codehaus.groovy.reflection.CachedMethod

- All Implemented Interfaces:
    Cloneable, Comparable

      public class CachedMethod
      extends MetaMethod
      implements Comparable

  Author:
    Alex.Tkachman

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `CachedClass` | `cachedClass`

    - ### Fields inherited from class org.codehaus.groovy.reflection.ParameterTypes

      `isVargsMethod, nativeParamTypes, parameterTypes`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CachedMethod(CachedClass clazz, Method method)`
    `CachedMethod(Method method)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compareTo(Object o)`
    `CallSite` | `createPogoMetaMethodSite(CallSite site, MetaClassImpl metaClass, Class[] params)`
    `CallSite` | `createPojoMetaMethodSite(CallSite site, MetaClassImpl metaClass, Class[] params)`
    `CallSite` | `createStaticMetaMethodSite(CallSite site, MetaClassImpl metaClass, Class[] params)`
    `boolean` | `equals(Object o)`
    `static CachedMethod` | `find(Method method)`
    `Method` | `getCachedMethod()`
    `CachedClass` | `getDeclaringClass()`
    `String` | `getDescriptor()`
    `int` | `getModifiers()`
    `String` | `getName()`
    `int` | `getParamsCount()`
    `ParameterTypes` | `getParamTypes()`
    `protected Class[]` | `getPT()`
    `Class` | `getReturnType()`
    `String` | `getSignature()`
    `int` | `hashCode()`
    `boolean` | `hasPogoCallSiteConstructor()`
    `boolean` | `hasPojoCallSiteConstructor()`
    `boolean` | `hasStaticCallSiteConstructor()`
    `Object` | `invoke(Object object, Object[] arguments)`
    `boolean` | `isStatic()`
    `Method` | `setAccessible()`
    `String` | `toString()`

    - ### Methods inherited from class groovy.lang.MetaMethod

      `checkParameters, clone, doMethodInvoke, equal, equal, getMopName, isAbstract, isCacheable, isMethod, isPrivate, isProtected, isPublic, isSame, processDoMethodInvokeException`

    - ### Methods inherited from class org.codehaus.groovy.reflection.ParameterTypes

      `coerceArgumentsToClasses, correctArguments, getNativeParameterTypes, getParameterTypes, isValidExactMethod, isValidExactMethod, isValidMethod, isValidMethod, isVargsMethod, setParametersTypes`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### cachedClass

          public final CachedClass cachedClass

  - ### Constructor Detail

    - #### CachedMethod

          public CachedMethod(CachedClass clazz,
                      Method method)

    - #### CachedMethod

          public CachedMethod(Method method)

  - ### Method Detail

    - #### find

          public static CachedMethod find(Method method)

    - #### getPT

          protected Class[] getPT()

      Overrides:
        `getPT` in class `ParameterTypes`

    - #### getName

          public String getName()

      Specified by:
        `getName` in class `MetaMethod`

    - #### getDescriptor

          public String getDescriptor()

      Overrides:
        `getDescriptor` in class `MetaMethod`

    - #### getDeclaringClass

          public CachedClass getDeclaringClass()

      Specified by:
        `getDeclaringClass` in class `MetaMethod`

    - #### invoke

          public final Object invoke(Object object,
                      Object[] arguments)

      Specified by:
        `invoke` in class `MetaMethod`

    - #### getParamTypes

          public ParameterTypes getParamTypes()

    - #### getReturnType

          public Class getReturnType()

      Specified by:
        `getReturnType` in class `MetaMethod`

    - #### getParamsCount

          public int getParamsCount()

    - #### getModifiers

          public int getModifiers()

      Specified by:
        `getModifiers` in class `MetaMethod`

    - #### getSignature

          public String getSignature()

      Overrides:
        `getSignature` in class `MetaMethod`

    - #### setAccessible

          public final Method setAccessible()

    - #### isStatic

          public boolean isStatic()

      Overrides:
        `isStatic` in class `MetaMethod`

    - #### compareTo

          public int compareTo(Object o)

      Specified by:
        `compareTo` in interface `Comparable`

    - #### equals

          public boolean equals(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `MetaMethod`

    - #### createPogoMetaMethodSite

          public CallSite createPogoMetaMethodSite(CallSite site,
                                          MetaClassImpl metaClass,
                                          Class[] params)

    - #### createPojoMetaMethodSite

          public CallSite createPojoMetaMethodSite(CallSite site,
                                          MetaClassImpl metaClass,
                                          Class[] params)

    - #### createStaticMetaMethodSite

          public CallSite createStaticMetaMethodSite(CallSite site,
                                            MetaClassImpl metaClass,
                                            Class[] params)

    - #### hasPogoCallSiteConstructor

          public boolean hasPogoCallSiteConstructor()

    - #### hasPojoCallSiteConstructor

          public boolean hasPojoCallSiteConstructor()

    - #### hasStaticCallSiteConstructor

          public boolean hasStaticCallSiteConstructor()

    - #### getCachedMethod

          public Method getCachedMethod()